#define _ARTCAMSDK_


#define WM_GRAPHNOTIFY  WM_APP + 1
#define WM_GRAPHPAINT	WM_APP + 2
#define WM_ERROR		WM_APP + 3


enum {
	ARTCAM_CAMERATYPE_DS			= 1,	
	ARTCAM_CAMERATYPE_DISABLE1		= 2,	
	ARTCAM_CAMERATYPE_USTC			= 3,	
	ARTCAM_CAMERATYPE_CNV			= 4,	
	ARTCAM_CAMERATYPE_DISABLE2		= 5,	
	ARTCAM_CAMERATYPE_130MI			= 6,	
	ARTCAM_CAMERATYPE_DISABLE3		= 7,	
	ARTCAM_CAMERATYPE_200MI			= 8,	
	ARTCAM_CAMERATYPE_300MI			= 9,	
	ARTCAM_CAMERATYPE_150P			= 10,	
	ARTCAM_CAMERATYPE_320P			= 11,	
	ARTCAM_CAMERATYPE_DISABLE4		= 12,	
	ARTCAM_CAMERATYPE_200SH			= 13,	
	ARTCAM_CAMERATYPE_098			= 14,	
	ARTCAM_CAMERATYPE_036MI			= 15,	
	ARTCAM_CAMERATYPE_500P			= 16,	
	ARTCAM_CAMERATYPE_150P2			= 17,	
	ARTCAM_CAMERATYPE_036MIST		= 18,	
	ARTCAM_CAMERATYPE_500MI			= 19,	
	ARTCAM_CAMERATYPE_T111			= 20,	
	ARTCAM_CAMERATYPE_T112			= 21,	
	ARTCAM_CAMERATYPE_150P3			= 22,	
	ARTCAM_CAMERATYPE_130MI_MOUT	= 23,	
	ARTCAM_CAMERATYPE_150P3_MOUT	= 24,	
	ARTCAM_CAMERATYPE_267KY			= 25,	
	ARTCAM_CAMERATYPE_274KY			= 26,	
	ARTCAM_CAMERATYPE_625KY			= 27,	
	ARTCAM_CAMERATYPE_V135MI		= 28,	
	ARTCAM_CAMERATYPE_445KY			= 29,	
	ARTCAM_CAMERATYPE_098II			= 30,	
	ARTCAM_CAMERATYPE_MV413			= 31,	
	
	ARTCAM_CAMERATYPE_300MI_STR2	= 104,	
	ARTCAM_CAMERATYPE_500MI_STR2	= 105,	
	ARTCAM_CAMERATYPE_D131_EIO		= 110,  
	ARTCAM_CAMERATYPE_022MI_EIO		= 111,  
	
	ARTCAM_CAMERATYPE_SATA			= 201,	
};

enum {
	ARTCAM_CAMERATYPE_SATA_LVDS		= 0,
	ARTCAM_CAMERATYPE_SATA_300MI	= 1,
	ARTCAM_CAMERATYPE_SATA_500MI	= 2,
	ARTCAM_CAMERATYPE_SATA_MV413	= 3,
	ARTCAM_CAMERATYPE_SATA_800MI	= 4,
	ARTCAM_CAMERATYPE_SATA_036MI	= 5,
	ARTCAM_CAMERATYPE_SATA_150P		= 6,
	ARTCAM_CAMERATYPE_SATA_267KY	= 6,
	ARTCAM_CAMERATYPE_SATA_274KY	= 7,
	ARTCAM_CAMERATYPE_SATA_625KY	= 8,
	ARTCAM_CAMERATYPE_SATA_130MI	= 9,
	ARTCAM_CAMERATYPE_SATA_200MI	=10,
};


enum {
	ARTCAMSDK_NOERROR = 0,		
	ARTCAMSDK_NOT_INITIALIZE,	
	ARTCAMSDK_DISABLEDDEVICE,	
	ARTCAMSDK_CREATETHREAD,		
	ARTCAMSDK_CREATEWINDOW,		
	ARTCAMSDK_OUTOFMEMORY,		
	ARTCAMSDK_CAMERASET,		
	ARTCAMSDK_CAMERASIZE,		
	ARTCAMSDK_CAPTURE,			
	ARTCAMSDK_PARAM,			
	ARTCAMSDK_DIRECTSHOW,		
	ARTCAMSDK_UNSUPPORTED,		
	ARTCAMSDK_UNKNOWN,			
	ARTCAMSDK_CAPTURELOST,		
	ARTCAMSDK_FILENOTFOUND,		
	ARTCAMSDK_FPGASET,			
	ARTCAMSDK_TRANSIMAGEFAILED,	
};

typedef struct GP_INFO {
	long	lSize;			
	long	lWidth;			
	long	lHeight;		
	long	lBpp;			
	long	lFps;			
	unsigned char*	pImage;			
} *LPGP_INFO;

typedef struct CAMERAINFO {
	long	lSize;				
	long	lWidth;				
	long	lHeight;			
	long	lGlobalGainMin;		
	long	lGlobalGainMax;		
	long	lColorGainMin;		
	long	lColorGainMax;		
	long	lExposureMin;		
	long	lExposureMax;		
} *LPCAMERAINFO;


enum {
	ARTCAM_FILTERTYPE_RESERVE = 0,			
	ARTCAM_FILTERTYPE_BRIGHTNESS,			
	ARTCAM_FILTERTYPE_CONTRAST,				
	ARTCAM_FILTERTYPE_HUE,					
	ARTCAM_FILTERTYPE_SATURATION,			
	ARTCAM_FILTERTYPE_SHARPNESS,			
	ARTCAM_FILTERTYPE_BAYER_GAIN_RGB,		
	ARTCAM_FILTERTYPE_BAYER_GAIN_R,			
	ARTCAM_FILTERTYPE_BAYER_GAIN_G,			
	ARTCAM_FILTERTYPE_BAYER_GAIN_B,			
	ARTCAM_FILTERTYPE_BAYER_GAIN_AUTO,		
	ARTCAM_FILTERTYPE_GAMMA,				
	ARTCAM_FILTERTYPE_BAYERMODE,			
	ARTCAM_FILTERTYPE_GLOBAL_GAIN,			
	ARTCAM_FILTERTYPE_COLOR_GAIN_R,			
	ARTCAM_FILTERTYPE_COLOR_GAIN_G1,		
	ARTCAM_FILTERTYPE_COLOR_GAIN_G2,		
	ARTCAM_FILTERTYPE_COLOR_GAIN_B,			
	ARTCAM_FILTERTYPE_EXPOSURETIME,			
	ARTCAM_FILTERTYPE_GRAY_MODE,			
	ARTCAM_FILTERTYPE_GRAY_GAIN_R,			
	ARTCAM_FILTERTYPE_GRAY_GAIN_G1,			
	ARTCAM_FILTERTYPE_GRAY_GAIN_G2,			
	ARTCAM_FILTERTYPE_GRAY_GAIN_B,			
	ARTCAM_FILTERTYPE_GRAY_OFFSET_R,		
	ARTCAM_FILTERTYPE_GRAY_OFFSET_G1,		
	ARTCAM_FILTERTYPE_GRAY_OFFSET_G2,		
	ARTCAM_FILTERTYPE_GRAY_OFFSET_B,		
};

#define ARTCAM_FILTERTYPE_RGB_GAIN		ARTCAM_FILTERTYPE_BAYER_GAIN_RGB
#define ARTCAM_FILTERTYPE_R_GAIN		ARTCAM_FILTERTYPE_BAYER_GAIN_R
#define ARTCAM_FILTERTYPE_G_GAIN		ARTCAM_FILTERTYPE_BAYER_GAIN_G
#define ARTCAM_FILTERTYPE_B_GAIN		ARTCAM_FILTERTYPE_BAYER_GAIN_B
#define ARTCAM_FILTERTYPE_AUTO_GAIN		ARTCAM_FILTERTYPE_BAYER_GAIN_AUTO


enum {
	SUBSAMPLE_1 = 0,	
	SUBSAMPLE_2,		
	SUBSAMPLE_4,		
	SUBSAMPLE_8,		
};


enum {
	AI_NONE = 0,		
	AI_EXPOSURE,		
	AI_GAIN,			
};


enum {
	GRAY_NONE = 0,		
	GRAY_BAYERCONVERT,	
	GRAY_GRAYSCALE,		
};


enum {
	VIDEOFORMAT_NTSC = 0,	
	VIDEOFORMAT_PAL,		
	VIDEOFORMAT_PALM,		
	VIDEOFORMAT_SECAM,		
};

enum {
	WIDE_HISPEED = 0,	
	WIDE_LOWSPEED,		
	NORMAL_HISPEED,		
	NORMAL_LOWSPEED,	
};



enum {
	FILETYPE_BITMAP = 0,
	FILETYPE_RAW,		
	FILETYPE_JPEG_HIGH,	
	FILETYPE_JPEG_NOMAL,
	FILETYPE_JPEG_LOW,	
	FILETYPE_PNG,		
	FILETYPE_TIFF,		
};





	 unsigned long		ArtCam_GetDllVersion		(void);
	 long		ArtCam_GetLastError			(unsigned long hACam);

	 unsigned long		ArtCam_Initialize			(unsigned long hWnd);
	 int		ArtCam_Release				(unsigned long hACam);

	 int		ArtCam_Preview				(unsigned long hACam);
	 int		ArtCam_Record				(unsigned long hACam, char* lpAviName, unsigned int RecTime, int fShow);
	 int		ArtCam_CallBackPreview		(unsigned long hACam, unsigned long hWnd, unsigned char* lpImage, long Size, int TopDown);
	 int		ArtCam_Close				(unsigned long hACam);

	 int		ArtCam_SnapShot				(unsigned long hACam, unsigned char* lpImage, long Size, int TopDown);

	 int		ArtCam_Capture				(unsigned long hACam);

	 int		ArtCam_Trigger				(unsigned long hACam, unsigned long hWnd, unsigned char* lpImage, long Size, int TopDown);
	 int		ArtCam_SaveImage			(unsigned long hACam, char* lpSaveName, long FileType);


	 int		ArtCam_SetPreviewWindow		(unsigned long hACam, unsigned long hWnd, long Left, long Top, long Right, long Bottom);
	 int		ArtCam_SetCaptureWindow		(unsigned long hACam, long Width, long Height, long Fps);
	 int		ArtCam_SetCaptureWindowEx	(unsigned long hACam, long HTotal, long HStart, long HEffective, long VTotal, long VStart, long VEffective);
	 int		ArtCam_GetCaptureWindowEx	(unsigned long hACam, long* HTotal, long* HStart, long* HEffective, long* VTotal, long* VStart, long* VEffective);

	 int		ArtCam_SetColorMode			(unsigned long hACam, long ColorMode);
	 long		ArtCam_GetColorMode			(unsigned long hACam);

	 int		ArtCam_SetCrossbar			(unsigned long hACam, long Output, long Input);
	 int		ArtCam_SetDeviceNumber		(unsigned long hACam, long Number);
	 long		ArtCam_EnumDevice			(unsigned long hACam, char szDeviceName[10][256]);
	 int		ArtCam_GetDeviceName		(unsigned long hACam, long index, char* szDeviceName, long nSize);

	 int		ArtCam_StartPreview			(unsigned long hACam);
	 int		ArtCam_StopPreview			(unsigned long hACam);
	 int		ArtCam_GetImage				(unsigned long hACam, unsigned char* lpImage, long Size, int TopDown);

	 long		ArtCam_Width				(unsigned long hACam);
	 long		ArtCam_Height				(unsigned long hACam);
	 long		ArtCam_Fps					(unsigned long hACam);

	 int		ArtCam_SetCameraDlg			(unsigned long hACam, unsigned long hWnd);
	 int		ArtCam_SetImageDlg			(unsigned long hACam, unsigned long hWnd);
	 int		ArtCam_SetAnalogDlg			(unsigned long hACam, unsigned long hWnd);

	 int		ArtCam_SetIOPort			(unsigned long hACam, unsigned char byteData, long longData, unsigned long Reserve);
	 int		ArtCam_GetIOPort			(unsigned long hACam, unsigned char* byteData, long* longData, unsigned long Reserve);

	 int		ArtCam_SetFilterValue		(unsigned long hACam, long FilterType, long Value);
	 long		ArtCam_GetFilterValue		(unsigned long hACam, long FilterType, int* Error);
	 int 		ArtCam_SetSubSample			(unsigned long hACam, long SubSampleMode);
	 long		ArtCam_GetSubSample			(unsigned long hACam);

	 int		ArtCam_SetWaitTime			(unsigned long hACam, long WaitTime);
	 long		ArtCam_GetWaitTime			(unsigned long hACam);

	 int		ArtCam_SetMirrorV			(unsigned long hACam, int Flg);
	 int		ArtCam_GetMirrorV			(unsigned long hACam);

	 int		ArtCam_SetMirrorH			(unsigned long hACam, int Flg);
	 int		ArtCam_GetMirrorH			(unsigned long hACam);

	 int		ArtCam_SetBrightness		(unsigned long hACam, long Value);
	 long		ArtCam_GetBrightness		(unsigned long hACam, int* Error);

	 int		ArtCam_SetContrast			(unsigned long hACam, long Value);
	 long		ArtCam_GetContrast			(unsigned long hACam, int* Error);

	 int		ArtCam_SetHue				(unsigned long hACam, long Value);
	 long		ArtCam_GetHue				(unsigned long hACam, int* Error);

	 int		ArtCam_SetSaturation		(unsigned long hACam, long Value);
	 long		ArtCam_GetSaturation		(unsigned long hACam, int* Error);

	 int		ArtCam_SetSharpness			(unsigned long hACam, long Value);
	 long		ArtCam_GetSharpness			(unsigned long hACam, int* Error);

	 int		ArtCam_SetBayerGainRGB		(unsigned long hACam, long Value);
	 long		ArtCam_GetBayerGainRGB		(unsigned long hACam, int* Error);

	 int		ArtCam_SetBayerGainRed		(unsigned long hACam, long Value);
	 long		ArtCam_GetBayerGainRed		(unsigned long hACam, int* Error);

	 int		ArtCam_SetBayerGainGreen	(unsigned long hACam, long Value);
	 long		ArtCam_GetBayerGainGreen	(unsigned long hACam, int* Error);

	 int		ArtCam_SetBayerGainBlue		(unsigned long hACam, long Value);
	 long		ArtCam_GetBayerGainBlue		(unsigned long hACam, int* Error);

	 int		ArtCam_SetBayerGainAuto		(unsigned long hACam, long Value);
	 long		ArtCam_GetBayerGainAuto		(unsigned long hACam, int* Error);

	 int		ArtCam_SetGamma				(unsigned long hACam, long Value);
	 long		ArtCam_GetGamma				(unsigned long hACam, int* Error);

	 int		ArtCam_SetBayerMode			(unsigned long hACam, long Value);
	 long		ArtCam_GetBayerMode			(unsigned long hACam, int* Error);

	 int		ArtCam_SetGlobalGain		(unsigned long hACam, long Value);
	 long		ArtCam_GetGlobalGain		(unsigned long hACam, int* Error);

	 int		ArtCam_SetColorGainRed		(unsigned long hACam, long Value);
	 long		ArtCam_GetColorGainRed		(unsigned long hACam, int* Error);

	 int		ArtCam_SetColorGainGreen1	(unsigned long hACam, long Value);
	 long		ArtCam_GetColorGainGreen1	(unsigned long hACam, int* Error);

	 int		ArtCam_SetColorGainGreen2	(unsigned long hACam, long Value);
	 long		ArtCam_GetColorGainGreen2	(unsigned long hACam, int* Error);

	 int		ArtCam_SetColorGainBlue		(unsigned long hACam, long Value);
	 long		ArtCam_GetColorGainBlue		(unsigned long hACam, int* Error);

	 int		ArtCam_SetExposureTime		(unsigned long hACam, long Value);
	 long		ArtCam_GetExposureTime		(unsigned long hACam, int* Error);

	 int		ArtCam_SetHalfClock			(unsigned long hACam, long Value);
	 long		ArtCam_GetHalfClock			(unsigned long hACam, int* Error);

	 int		ArtCam_SetAutoIris			(unsigned long hACam, long Value);
	 long		ArtCam_GetAutoIris			(unsigned long hACam, int* Error);

	 int		ArtCam_SetSamplingRate		(unsigned long hACam, long Value);
	 long		ArtCam_GetSamplingRate		(unsigned long hACam, int* Error);

	 long		ArtCam_GetVideoFormat		(unsigned long hACam, int* Error);

	 int		ArtCam_WriteSromID			(unsigned long hACam, long Address, long Value);
	 long		ArtCam_ReadSromID			(unsigned long hACam, long Address, int* Error);


	 int		ArtCam_GetCameraInfo		(unsigned long hACam, LPCAMERAINFO pInfo);
	 long		ArtCam_GetSatus			(unsigned long hACam, int* Error);

	 int		ArtCam_WriteRegister		(unsigned long hACam, unsigned char Address, unsigned long Value);
	 unsigned long		ArtCam_ReadRegister			(unsigned long hACam, unsigned char Address, int* Error);

	 int		ArtCam_SetGrayMode			(unsigned long hACam, long Value);
	 long		ArtCam_GetGrayMode			(unsigned long hACam, int* Error);
	 int		ArtCam_SetGrayGainR			(unsigned long hACam, long Value);
	 long		ArtCam_GetGrayGainR			(unsigned long hACam, int* Error);
	 int		ArtCam_SetGrayGainG1		(unsigned long hACam, long Value);
	 long		ArtCam_GetGrayGainG1		(unsigned long hACam, int* Error);
	 int		ArtCam_SetGrayGainG2		(unsigned long hACam, long Value);
	 long		ArtCam_GetGrayGainG2		(unsigned long hACam, int* Error);
	 int		ArtCam_SetGrayGainB			(unsigned long hACam, long Value);
	 long		ArtCam_GetGrayGainB			(unsigned long hACam, int* Error);
	 int		ArtCam_SetGrayOffsetR		(unsigned long hACam, long Value);
	 long		ArtCam_GetGrayOffsetR		(unsigned long hACam, int* Error);
	 int		ArtCam_SetGrayOffsetG1		(unsigned long hACam, long Value);
	 long		ArtCam_GetGrayOffsetG1		(unsigned long hACam, int* Error);
	 int		ArtCam_SetGrayOffsetG2		(unsigned long hACam, long Value);
	 long		ArtCam_GetGrayOffsetG2		(unsigned long hACam, int* Error);
	 int		ArtCam_SetGrayOffsetB		(unsigned long hACam, long Value);
	 long		ArtCam_GetGrayOffsetB		(unsigned long hACam, int* Error);

	 int		ArtCam_SetCameraType		(unsigned long hACam, long Flg);
	 long		ArtCam_GetCameraType		(unsigned long hACam, int* Error);

	 int		ArtCam_Fpga_WriteRegister	(unsigned long hACam, BYTE Address, unsigned long Value);
	 unsigned long		ArtCam_Fpga_ReadRegister	(unsigned long hACam, BYTE Address, int* Error);

	 int		ArtCam_Monitor_SetPreviewMode		(unsigned long hACam, int Preview);
	 int		ArtCam_Monitor_GetPreviewMode		(unsigned long hACam, int* Error);
	 int		ArtCam_Monitor_SetPreviewSize		(unsigned long hACam, long Width, long Height);
	 int		ArtCam_Monitor_GetPreviewSize		(unsigned long hACam, long* Width, long* Height);
	 int		ArtCam_Monitor_SetColorMode			(unsigned long hACam, int ColorMode);
	 int		ArtCam_Monitor_GetColorMode			(unsigned long hACam, int* Error);
	 int		ArtCam_Monitor_SetCameraClock		(unsigned long hACam, long Value);
	 long		ArtCam_Monitor_GetCameraCLock		(unsigned long hACam, int* Error);
	 int		ArtCam_Monitor_SetBayerGainAuto		(unsigned long hACam, long Value);
	 long		ArtCam_Monitor_GetBayerGainAuto		(unsigned long hACam, int* Error);
	 int		ArtCam_Monitor_SetBayerGainLock		(unsigned long hACam, long Value);
	 long		ArtCam_Monitor_GetBayerGainLock		(unsigned long hACam, int* Error);
	 int		ArtCam_Monitor_SetBayerGainRed		(unsigned long hACam, long Value);
	 long		ArtCam_Monitor_GetBayerGainRed		(unsigned long hACam, int* Error);
	 int		ArtCam_Monitor_SetBayerGainGreen	(unsigned long hACam, long Value);
	 long		ArtCam_Monitor_GetBayerGainGreen	(unsigned long hACam, int* Error);
	 int		ArtCam_Monitor_SetBayerGainBlue		(unsigned long hACam, long Value);
	 long		ArtCam_Monitor_GetBayerGainBlue		(unsigned long hACam, int* Error);





